;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.2 - GPL3 - Apr 2012
;
;-----------------------------------------------------------------------------------
;
; Include file for BareNumbersOS program development
;-----------------------------------------------------------------------------------

sys_tab:
;debug
sys_debug_dump_reg		dq 0	; 001 - Dump the registers to the screen
sys_debug_dump_mem		dq 0	; 002 - Dump contents of memory to the screen. IN: RSI = Start of memory address to dump, RCX = number of bytes to dump
sys_debug_dump_rax		dq 0	; 003 - Dump the content of RAX (64-bit) to the screen
sys_debug_dump_eax		dq 0	; 004 - Dump the content of EAX (32-bit) to the screen
sys_debug_dump_ax		dq 0	; 005 - Dump the content of AX (16-bit) to the screen
sys_debug_dump_al		dq 0	; 006 - Dump the content of AL (8-bit) to the screen
;file
sys_fs_command_break		dq 0	; 007 - Break the contents of string into individual strings. IN: RSI = command arguments string. OUT: RSI = command arguments string (breaked), RCX = num. of words in the string
sys_fs_command			dq 0	; 008 - File system commands executor. IN: RSI = command arguments string (breaked) RCX = num. of words in the string, RAX = ptr to file in memory (STO), RBX = size (STO)
					; 				      OUT: RAX = ptr to file in memory	(LIM), RBX = size (LIM), set carry
;input
sys_input_key_check		dq 0	; 009 - Scans keyboard for input, but doesn't wait. OUT: AL = ASCII code or 0 if no key pressed
sys_input_key_wait		dq 0	; 010 - Waits for keypress and returns key. OUT: AL = key pressed
sys_input_string		dq 0	; 011 - Take string from keyboard entry. IN: RDI = location where string will be stored. RCX = max chars to accept
;memory
sys_mem_allocate		dq 0	; 012 - Allocates the requested number of 2 MiB pages. IN: RCX = Number of pages to allocate. OUT: RAX = Starting address, RCX = Number of pages allocated (Set to the value asked for or 0 on failure)
sys_mem_release			dq 0	; 013 - Frees the requested number of 2 MiB pages. IN: RAX = Starting address, RCX = Number of pages to free. OUT: RCX = Number of pages freed
sys_mem_get_free		dq 0	; 014 - Returns the number of 2 MiB pages that are available. OUT: RCX = Number of free 2 MiB pages
;misc
sys_get_timecounter		dq 0	; 015 - Get the current RTC clock couter value. OUT: RAX = Time in eights of a second since clock started
sys_delay			dq 0	; 016 - Pause for a set time. IN: RAX = Time in hundredths of a second
sys_get_random			dq 0    ; 017 - Return a random integer OUT: RAX = Random number
sys_get_random_integer		dq 0    ; 018 - Return a random integer between Low and High (incl) IN: RAX = Low integer RBX = High integer. OUT: RCX = Random integer
sys_get_argc			dq 0	; 019 - Return the number arguments passed to the program (RUN string) OUT: AL = Number of arguments
sys_get_argv			dq 0	; 020 - Get the value of an argument that was passed to the program. IN: AL = Argument number. OUT: RSI = Start of numbered argument string
sys_get_strv			dq 0	; 021 - Get the value from a string to parse ; IN: AL  = Value number AH  = Delimiter RSI = String. OUT: RSI = Start of numbered value string
;screen
sys_move_cursor			dq 0	; 022 - Move the cursor on screen. IN: AL = column, AH = row
sys_inc_cursor			dq 0	; 023 - Increment the hardware cursor by one
sys_dec_cursor			dq 0	; 024 - Decrement the hardware cursor by one
sys_print_newline		dq 0	; 025 - Print a new line
sys_print_string		dq 0	; 026 - Displays text. IN: RSI = message location (zero-terminated string)
sys_print_string_with_color	dq 0	; 027 - Displays text in colour. IN: RSI = message location (zero-terminated string), BL = colour
sys_print_char			dq 0	; 028 - Displays a char. IN: AL = char to display
sys_print_char_with_color	dq 0	; 029 - Displays a char in colour. IN: AL = char to display, BL = colour
sys_print_chars			dq 0	; 030 - Displays text. IN: RSI = message location (A string, not zero-terminated), RCX = number of chars to print
sys_print_chars_with_color	dq 0	; 031 - Displays text with color. IN: RSI = message location (A string, not zero-terminated), BL = color, RCX = number of chars to print
sys_print_char_hex		dq 0	; 032 - Displays a char in hex mode. IN: AL = char to display
sys_print_char_hex_with_color	dq 0	; 033 - Displays a char in hex mode with color. IN: AL = char to display, BL = colour
sys_screen_scroll		dq 0	; 034 - Scrolls the screen up by one line
sys_screen_clear		dq 0	; 035 - Clear the screen
sys_screen_clear_from_cursor	dq 0	; 036 - Clear the screen from cursor to end
sys_row_clear			dq 0	; 037 - Clear a row. IN: AL  = row to clear
sys_hide_cursor			dq 0	; 038 - Turns off cursor in text mode
sys_show_cursor			dq 0	; 039 - Turns on cursor in text mode
;smp
sys_smp_reset			dq 0	; 040 - Resets a CPU/Core. IN: AL = CPU #
sys_smp_wakeup			dq 0	; 041 - Wake up a CPU Core. IN:	AL = CPU #
sys_smp_wakeup_all		dq 0	; 042 - Wake up all CPU Cores
sys_smp_get_id			dq 0	; 043 - Returns the APIC ID of the CPU that ran this function. OUT: RAX = CPU's APIC ID number
sys_smp_enqueue			dq 0	; 044 - Add a workload to the processing queue. IN: RAX = Code to execute, RBX = Variable/Data to work on
sys_smp_dequeue			dq 0	; 045 - Dequeue a workload from the processing queue. OUT: RAX = Code to execute, RBX = Variable/Data to work on
sys_smp_run			dq 0	; 046 - Call the function address in RAX. IN: RAX = Memory location of code to run
sys_smp_queuelen		dq 0	; 047 - Returns the number of items in the processing queue. OUT: RAX = number of items in processing queue
sys_smp_numcores		dq 0	; 048 - Returns the number of cores in this computer. OUT: RAX = number of cores in this computer
sys_smp_wait			dq 0	; 049 - Wait until all other CPU Cores are finished processing
sys_smp_lock			dq 0	; 050 - Lock a variable. IN: RAX = Memory address of variable
sys_smp_unlock			dq 0	; 051 - Unlock a variable. IN: RAX = Memory address of variable
;sound
sys_speaker_tone		dq 0	; 052 - Generate PC speaker tone (call sys_speaker_off after). IN: RAX = note frequency
sys_speaker_on			dq 0	; 053 - Turn on PC speaker
sys_speaker_off			dq 0	; 054 - Shut off the PC speaker
sys_speaker_beep		dq 0	; 055 - Play a standard beep noise
;string
sys_int_to_string		dq 0	; 056 - Convert an integer to a string. IN: RAX = interger. OUT: RDI = destination string
sys_string_to_int		dq 0	; 057 - Convert a string to an interger. IN: RSI = source string. OUT: RAX = interger
sys_int_to_hex_string		dq 0	; 058 - Convert an integer to a hex string. IN: RAX = Integer value. RDI = location to store string
sys_hex_string_to_int		dq 0	; 059 - Convert up to 8 hexascii to bin. IN: RSI = Location of hex asciiz string. OUT: RAX = binary value of hex string
sys_string_length		dq 0	; 060 - Return the length of a string. IN: RSI = string address. OUT: RCX = string length
sys_string_find_char		dq 0	; 061 - Find first location of character in a string. IN: RSI = string location, AL = character to find. OUT: RAX = location in string, or 0 if char not present
sys_string_change_char		dq 0	; 062 - Change all instances of a character in a string. IN: RSI = string location, AL = character to replace, BL = replacement character
sys_string_copy			dq 0	; 063 - Copy the contents of one string into another. IN: RSI = source, RDI = destination
sys_string_truncate		dq 0	; 064 - Chop string down to specified number of characters. IN: RSI = string location, RAX = number of characters
sys_string_join			dq 0	; 065 - Join two strings into a third string. IN: RAX = string one, RBX = string two, RDI = destination string
sys_string_append		dq 0	; 066 - Append a string to an existing string. IN: RSI = String to be appended, RDI = Destination string
sys_string_chomp		dq 0	; 067 - Strip leading and trailing spaces from a string. IN: RSI = string location
sys_string_strip		dq 0	; 068 - Removes specified character from a string. IN: RSI = string location, AL = character to remove
sys_string_compare		dq 0	; 069 - See if two strings match. IN: RSI = string one, RDI = string two. OUT: Carry flag set if same
sys_string_uppercase		dq 0	; 070 - Convert a string to all uppercase characters. IN: RSI = string address
sys_string_lowercase		dq 0	; 071 - Convert a string to all lowercase characters. IN: RSI = string address
sys_is_digit			dq 0	; 072 - Check if character is a digit. IN: AL = ASCII char. OUT: EQ flag set if numeric
sys_is_alpha			dq 0	; 073 - Check if character is a letter. IN: AL = ASCII char. OUT: EQ flag set if alpha
sys_string_parse		dq 0	; 074 - Parse a string into individual words. IN: RSI = Address of string. OUT: RCX = word count
sys_get_date_string		dq 0	; 075 - Get date. OUT: RSI point to date string
sys_get_time_string		dq 0	; 076 - Get time. OUT: RSI point to time string
sys_get_datetime_string		dq 0	; 077 - Get datetime stamp. OUT: RSI point to datetime string
sys_byte_to_8digit_string	dq 0	; 078 - Convert a byte to a 8 digit string.  IN: AL  binary byte, RDI point to 8digit string. OUT: RSI point to 8digit string


;---------------------------------------


init_syscalls_table:

	mov rsi, qword[0x0000000000005024]
	mov rdi, sys_tab
	mov rcx, 78
.next:
	mov rax, qword[rsi]
	mov qword[rdi], rax

	add rsi, 8
	add rdi, 8
	dec rcx

	cmp rcx, 0
	jne .next

	ret


; =============================================================================
; EOF
