;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.2 - GPL3 - Apr 2012
;
;-----------------------------------------------------------------------------------
; device descriptors
;-----------------------------------------------------------------------------------

align 16

	ata0.string		db 'ata0', 0
      	ata0.readsectors 	dq 0
      	ata0.writesectors 	dq 0
	ata0.base		dq 0x00000000000001F0
	ata0.id			dq 0x0000000000000000
	ata0.tLBA		dq 0
	ata0.present		db 0
	ata0.fs			db 0
	ata0.header		dq 0
	ata0.root		dq 0

	ata1.string		db 'ata1', 0
      	ata1.readsectors 	dq 0
      	ata1.writesectors 	dq 0
	ata1.base		dq 0x00000000000001F0
	ata1.id			dq 0x0000000000000010
	ata1.tLBA		dq 0
	ata1.present		db 0
	ata1.fs			db 0
	ata1.header		dq 0
	ata1.root		dq 0

	ata2.string		db 'ata2', 0
      	ata2.readsectors 	dq 0
      	ata2.writesectors 	dq 0
	ata2.base		dq 0x0000000000000170
	ata2.id			dq 0x0000000000000000
	ata2.tLBA		dq 0
	ata2.present		db 0
	ata2.fs			db 0
	ata2.header		dq 0
	ata2.root		dq 0

	ata3.string		db 'ata3', 0
      	ata3.readsectors 	dq 0
      	ata3.writesectors 	dq 0
	ata3.base		dq 0x0000000000000170
	ata3.id			dq 0x0000000000000010
	ata3.tLBA		dq 0
	ata3.present		db 0
	ata3.fs			db 0
	ata3.header		dq 0
	ata3.root		dq 0

	current.string		db 0,0,0,0,0
	current.readsectors	dq 0
	current.writesectors	dq 0
	current.base		dq 0
	current.id		dq 0
	current.tLBA		dq 0
	current.present		db 0
	current.fs		db 0
	current.header		dq 0
	current.root		dq 0



;-----------------------------------------------
; current_device
; IN :	eax = device
; OUT:	set carry
;-----------------------------------------------
current_device:

	cmp eax, 'ata0'
	je .ata0
	cmp eax, 'ata1'
	je .ata1
	cmp eax, 'ata2'
	je .ata2
	cmp eax, 'ata3'
	je .ata3

	jmp .nodevice

.ata0:
	mov eax, dword[ata0.string]
	mov dword[current.string], eax
	mov rax, [ata0.readsectors] 	     
	mov [current.readsectors], rax
	mov rax, [ata0.writesectors]
	mov [current.writesectors], rax
	mov rax, [ata0.base]
	mov [current.base], rax
	mov rax, [ata0.id]
	mov [current.id], rax
	mov rax, [ata0.tLBA]	     
	mov [current.tLBA], rax
	mov al, byte[ata0.present]       
	mov byte[current.present], al
     	mov al, byte[ata0.fs]       
	mov byte[current.fs], al
	mov rax, [ata0.header]
	mov [current.header], rax
	mov rax, [ata0.root]
	mov [current.root], rax
	jmp .ok
.ata1:
	mov eax, dword[ata1.string]
	mov dword[current.string], eax
	mov rax, [ata1.readsectors] 	     
	mov [current.readsectors], rax
	mov rax, [ata1.writesectors]
	mov [current.writesectors], rax
	mov rax, [ata1.base]
	mov [current.base], rax
	mov rax, [ata1.id]
	mov [current.id], rax
	mov rax, [ata1.tLBA]	     
	mov [current.tLBA], rax
	mov al, byte[ata1.present]       
	mov byte[current.present], al
     	mov al, byte[ata1.fs]       
	mov byte[current.fs], al
	mov rax, [ata1.header]
	mov [current.header], rax
	mov rax, [ata1.root]
	mov [current.root], rax 
	jmp .ok
.ata2:
	mov eax, dword[ata2.string]
	mov dword[current.string], eax
	mov rax, [ata2.readsectors] 	     
	mov [current.readsectors], rax
	mov rax, [ata2.writesectors]
	mov [current.writesectors], rax
	mov rax, [ata2.base]
	mov [current.base], rax
	mov rax, [ata2.id]
	mov [current.id], rax
	mov rax, [ata2.tLBA]	     
	mov [current.tLBA], rax
	mov al, byte[ata2.present]       
	mov byte[current.present], al 
     	mov al, byte[ata2.fs]       
	mov byte[current.fs], al
	mov rax, [ata2.header]
	mov [current.header], rax
	mov rax, [ata2.root]
	mov [current.root], rax
	jmp .ok
.ata3:
	mov eax, dword[ata3.string]
	mov dword[current.string], eax
	mov rax, [ata3.readsectors] 	     
	mov [current.readsectors], rax
	mov rax, [ata3.writesectors]
	mov [current.writesectors], rax
	mov rax, [ata3.base]
	mov [current.base], rax
	mov rax, [ata3.id]
	mov [current.id], rax
	mov rax, [ata3.tLBA]	     
	mov [current.tLBA], rax
	mov al, byte[ata3.present]       
	mov byte[current.present], al 
     	mov al, byte[ata3.fs]       
	mov byte[current.fs], al
	mov rax, [ata3.header]
	mov [current.header], rax
	mov rax, [ata3.root]
	mov [current.root], rax
	jmp .ok

.nodevice:
	stc
	jmp .end
.ok:
	clc
.end:

ret


; ===================================================================================================
; EOF

;--------------------------------------------------------
;hdbase  	dw 0		; 0x01F0 primary device
;				; 0x0170 secondary device
;hdid		db 0		; 0x00   master
;				; 0x10   slave
;--------------------------------------------------------

