;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.2 - GPL3 - Apr 2012
;
;-----------------------------------------------------------------------------------
; ATA Identify Information Structure
;-----------------------------------------------------------------------------------

align 16

;--------------------------------------------------------------------------------------------------------------------------------------

struc ATA_IDENTIFYDEVICE_STRUCTURE 
	{

      	.general_configuration		dw 0    	; 000	- bit 15 set to 0 = ATA device, bit 7 set to 1 = removable media device
	.cylinders			dw 0		; 001	- Obsolete
	.specific_configuration		dw 0		; 002	- 
	.heads				dw 0		; 003	- Obsolete
	.word004			dw 0		; 004	- Retired (track_bytes)
	.word005			dw 0		; 005	- Retired (sector_bytes)
	.sectors			dw 0		; 006	- Obsolete
	.vendor0cf			dw 0		; 007	- Reserved for assignment by the CompactFlashTM Association
	.vendor1cf			dw 0		; 008	- Reserved for assignment by the CompactFlashTM Association
	.word008			dw 0		; 009	- Retired (vendor2)
	.serial_number:	TIMES 20	db 0		; 010	- [20 ASCII characters : 10 words]
	.word020			dw 0		; 020	- Retired (buffer_type)
	.word021			dw 0		; 021	- Retired (buffer_size)
	.ecc_bytes			dw 0		; 022	- Obsolete
	.firmware_revision:  TIMES 8	db 0		; 023	- [8 ASCII characters : 4 words]
	.model_number:	TIMES 40	db 0		; 027	- [40 ASCII characters : 20 words]
	.read_write_multiple_command	dw 0		; 047	- bits 15-8 = 80h, bits 7-0 : 00h = Reserved or
							; 	  01h-FFh = Maximum number of sectors that shall be transferred per interrupt
							;         on READ/WRITE MULTIPLE commands
	.word048			dw 0		; 048	- Reserved (dword_io)
	.capabilities			dw 0		; 049	- bits 15-14 Reserved for the IDENTIFY PACKET DEVICE command.
							;	  bit 13 set to 1 = Standby timer values as specified in this standard are supported
							;	                0 = Standby timer values shall be managed by the device
							; 	  bit 12 Reserved for the IDENTIFY PACKET DEVICE command.
							;	  bit 11 set to 1 = IORDY supported
							;	  bit 11 set to 0 = IORDY may be supported
							;	  bit 10 set to 1 = IORDY may be disabled
							;	  bit 9 set to 1 = LBA supported
							;	  bit 8 set to 1 = DMA supported
							;	  bits 7-0 Retired (vendor4)
	.capabilities2			dw 0		; 050	- bit 0 Shall be set to one to indicate a device specific Standby timer value minimum.
	.word051			dw 0		; 051	- Obsolete (vendor5, tPIO)
	.word052			dw 0		; 052	- Obsolete (vendor6, tDMA)
	.fields_valid			dw 0		; 053	- bits 15-3 Reserved,
							; 	  bit 2 set to 1 = the fields reported in word 88 are valid
							; 	  bit 2 set to 0 = the fields reported in word 88 are not valid
							; 	  bit 1 set to 1 = the fields reported in words (70:64) are valid
							; 	  bit 1 set to 0 = the fields reported in words (70:64) are not valid
							;	  bit 0 Obsolete
	.word054			dw 0		; 054	- Obsolete (cur_cyls_logic)
	.word055			dw 0		; 055	- Obsolete (cur_heads_logic)
	.word056			dw 0		; 056	- Obsolete (cur_sectors_logic_par)
	.word057			dw 0		; 057	- Obsolete (cur_capacity0_tot_sectors)
	.word058			dw 0		; 058	- Obsolete (cur_capacity1_tot_sectors)
	.multiple_sector		dw 0		; 059	- bits 15-9 Reserved
							;	  bit 8 set to 1 = Multiple sector setting is valid
							;	  bit 7-0 set to xxh = Current setting for number of sectors that shall be
							;	  			transferred per interrupt on R/W Multiple command
	.lba_capacity			dd 0		; 060	- Total number of user addressable sectors [ 2 words ] (28bit)
	.dma_1word			dw 0		; 062	- Obsolete
	.dma_multiword			dw 0		; 063	- bits 15-11 Reserved
							;	  bit 10 set to 1 = Multiword DMA mode 2 is selected
							;	  bit 10 set to 0 = Multiword DMA mode 2 is not selected
							;	  bit 9 set to 1 = Multiword DMA mode 1 is selected
							;	  bit 9 set to 0 = Multiword DMA mode 1 is not selected
							;	  bit 8 set to 1 = Multiword DMA mode 0 is selected
							;	  bit 8 set to 0 = Multiword DMA mode 0 is not selected
							;	  bits 7-3 Reserved
							;	  bit 2 set to 1 = Multiword DMA mode 2 and below are supported
							;	  bit 1 set to 1 = Multiword DMA mode 1 and below are supported
							;	  bit 0 set to 1 = Multiword DMA mode 0 is supported
	.pio_modes			dw 0		; 064	- bits 15-8 Reserved, bits 7-0 PIO modes supported
	.minimum_multiword_DMA_time	dw 0		; 065	- Cycle time in nanoseconds
	.manufacter_multiword_DMA_time  dw 0		; 066	- Cycle time in nanoseconds
	.minimum_pio_time		dw 0		; 067	- Cycle time in nanoseconds
	.minimum_pio_time_with_IORDY	dw 0		; 068	- Cycle time in nanoseconds
	.word0069			dw 0		; 069	- Reserved
	.word0070			dw 0		; 070	- Reserved
	.word0071			dw 0		; 071	- Reserved
	.word0072			dw 0		; 072	- Reserved
	.word0073			dw 0		; 073	- Reserved
	.word0074			dw 0		; 074	- Reserved
	.queue_depth			dw 0		; 075	- bits 15-5 Reserved, bits 4-0 = Maximum queue depth - 1
	.word0076			dw 0		; 076	- Reserved for Serial ATA
	.word0077			dw 0		; 077	- Reserved for Serial ATA
	.word0078			dw 0		; 078	- Reserved for Serial ATA
	.word0079			dw 0		; 079	- Reserved for Serial ATA
	.major_version_number		dw 0		; 080	- 0000h or FFFFh = device does not report version
							;	  bit number set to 1 = ata-atapi number supported
	.minor_version_number		dw 0		; 081	- 0000h or FFFFh = device does not report version
	.command_sets1			dw 0		; 082	- bit 15 Obsolete
							; 	  bit 14 set to 1 = NOP command supported
							;	  bit 13 set to 1 = READ BUFFER command supported
							;	  bit 12 set to 1 = WRITE BUFFER command supported
							;	  bit 11 Obsolete
							;	  bit 10 set to 1 = Host Protected Area feature set supported
							;	  bit 9 set to 1 = DEVICE RESET command supported
							;	  bit 8 set to 1 = SERVICE interrupt supported
							;	  bit 7 set to 1 = release interrupt supported
							;	  bit 6 set to 1 = look-ahead supported
							;	  bit 5 set to 1 = write cache supported
							;	  bit 4 Shall be cleared to zero (PACKET Command feature set is not supported)
							;	  bit 3 set to 1 = mandatory Power Management feature set supported
							;	  bit 2 set to 1 = Removable Media feature set supported
							;	  bit 1 set to 1 = Security Mode feature set supported
							;	  bit 0 set to 1 = SMART feature set supported
	.command_sets2			dw 0		; 083	- bit 15 Shall be cleared to zero
							; 	  bit 14 Shall be set to one
							;	  bit 13 set to 1 = FLUSH CACHE EXT command supported
							;	  bit 12 set to 1 = mandatory FLUSH CACHE command supported
							;	  bit 11 set to 1 = Device Configuration Overlay feature set supported
							;	  bit 10 set to 1 = 48-bit Address feature set supported
							;	  bit 9 set to 1 = Automatic Acoustic Management feature set supported
							;	  bit 8 set to 1 = SET MAX security extension supported
							;	  bit 7 (See Address Offset Reserved Area Boot)
							;	  bit 6 set to 1 = SET FEATURES subcommand required to spinup
							;	  bit 5 set to 1 = Power-Up In Standby feature set supported
							;	  bit 4 set to 1 = Removable Media Status Notification feature set supported
							;	  bit 3 set to 1 = Advanced Power Management feature set supported
							;	  bit 2 set to 1 = CFA feature set supported
							;	  bit 1 set to 1 = READ/WRITE DMA QUEUED supported
							;	  bit 0 set to 1 = DOWNLOAD MICROCODE command supported
	.command_sets3			dw 0		; 084	- bit 15 Shall be cleared to zero
							; 	  bit 14 Shall be set to one
							;	  bit 13 set to 1 = IDLE IMMEDIATE with UNLOAD FEATURE supported
							;	  bit 12 Reserved for technical report
							;	  bit 11 Reserved for technical report
							;	  bit 10 set to 1 = URG bit supported for WRITE STREAM DMA EXT and WRITE STREAM EXT
							;	  bit 9 set to 1 = URG bit supported for READ STREAM DMA EXT and READ STREAM EXT
							;	  bit 8 set to 1 = 64-bit World wide name supported
							;	  bit 7 set to 1 = WRITE DMA QUEUED FUA EXT command supported
							;	  bit 6 set to 1 = WRITE DMA FUA EXT and WRITE MULTIPLE FUA EXT commands supported
							;	  bit 5 set to 1 = General Purpose Logging feature set supported
							;	  bit 4 set to 1 = Streaming feature set supported
							;	  bit 3 set to 1 = Media Card Pass Through Command feature set supported
							;	  bit 2 set to 1 = Media serial number supported
							;	  bit 1 set to 1 = SMART self-test supported
							;	  bit 0 set to 1 = SMART error logging supported
	.command_sets4			dw 0		; 085	- bit 15 Obsolete
							; 	  bit 14 set to 1 = NOP command enabled
							;	  bit 13 set to 1 = READ BUFFER command enabled
							;	  bit 12 set to 1 = WRITE BUFFER command enabled
							;	  bit 11 Obsolete
							;	  bit 10 set to 1 = Host Protected Area feature set enabled
							;	  bit 9 set to 1 = DEVICE RESET command enabled
							;	  bit 8 set to 1 = SERVICE interrupt enabled
							;	  bit 7 set to 1 = release interrupt enabled
							;	  bit 6 set to 1 = look-ahead enabled
							;	  bit 5 set to 1 = write cache enabled
							;	  bit 4 set to 1 = Shall be cleared to zero (PACKET Command not supported)
							;	  bit 3 set to 1 = Power Management feature set enabled
							;	  bit 2 set to 1 = Removable Media feature set enabled
							;	  bit 1 set to 1 = Security Mode feature set enabled
							;	  bit 0 set to 1 = SMART feature set enabled
	.command_sets5			dw 0		; 086	- bit 15 Reserved
							; 	  bit 14 Reserved
							;	  bit 13 set to 1 = FLUSH CACHE EXT command supported
							;	  bit 12 set to 1 = FLUSH CACHE command supported
							;	  bit 11 set to 1 = Device Configuration Overlay supported
							;	  bit 10 set to 1 = 48-bit Address features set supported
							;	  bit 9 set to 1 = Automatic Acoustic Management feature set enabled
							;	  bit 8 set to 1 = SET MAX security extension enabled by SET MAX SET PASSWORD 
							;	  bit 7 (See Address Offset Reserved Area Boot)
							;	  bit 6 set to 1 = SET FEATURES subcommand required to spin-up
							;	  bit 5 set to 1 = Power-Up In Standby feature set enabled
							;	  bit 4 set to 1 = Removable Media Status Notification feature set enabled
							;	  bit 3 set to 1 = Advanced Power Management feature set enabled
							;	  bit 2 set to 1 = CFA feature set enabled
							;	  bit 1 set to 1 = READ/WRITE DMA QUEUED command supported
							;	  bit 0 set to 1 = DOWNLOAD MICROCODE command supported
	.command_sets6			dw 0		; 087	- bit 15 Shall be cleared to zero
							; 	  bit 14 Shall be set to one
							;	  bit 13 set to 1 = IDLE IMMEDIATE with UNLOAD FEATURE supported
							;	  bit 12 Reserved for technical report
							;	  bit 11 Reserved for technical report
							;	  bit 10 set to 1 = URG bit supported for WRITE STREAM DMA EXT and WRITE STREAM EXT
							;	  bit 9 set to 1 = URG bit supported for READ STREAM DMA EXT and READ STREAM EXT
							;	  bit 8 set to 1 = 64-bit World wide name supported
							;	  bit 7 set to 1 = WRITE DMA QUEUED FUA EXT command supported
							;	  bit 6 set to 1 = WRITE DMA FUA EXT and WRITE MULTIPLE FUA EXT commands supported
							;	  bit 5 set to 1 = General Purpose Logging feature set supported
							;	  bit 4 set to 1 = Valid CONFIGURE STREAM command has been executed
							;	  bit 3 set to 1 = Media Card Pass Through Command feature set enabled
							;	  bit 2 set to 1 = Media serial number is valid
							;	  bit 1 set to 1 = SMART self-test supported
							;	  bit 0 set to 1 = SMART error logging supported
	.ultra_dma			dw 0		; 088	- bit 15 Reserved
							; 	  bit 14 set to 1 = Ultra DMA mode 6 is selected, set to 0 = is not selected
							;	  bit 13 set to 1 = Ultra DMA mode 5 is selected, set to 0 = is not selected
							;	  bit 12 set to 1 = Ultra DMA mode 4 is selected, set to 0 = is not selected
							;	  bit 11 set to 1 = Ultra DMA mode 3 is selected, set to 0 = is not selected
							;	  bit 10 set to 1 = Ultra DMA mode 2 is selected, set to 0 = is not selected
							;	  bit 9 set to 1 = Ultra DMA mode 1 is selected, set to 0 = is not selected
							;	  bit 8 set to 1 = Ultra DMA mode 0 is selected, set to 0 = is not selected
							;	  bit 7 Reserved
							;	  bit 6 set to 1 = Ultra DMA mode 6 and below are supported
							;	  bit 5 set to 1 = Ultra DMA mode 5 and below are supported
							;	  bit 4 set to 1 = Ultra DMA mode 4 and below are supported
							;	  bit 3 set to 1 = Ultra DMA mode 3 and below are supported
							;	  bit 2 set to 1 = Ultra DMA mode 2 and below are supported
							;	  bit 1 set to 1 = Ultra DMA mode 1 and below are supported
							;	  bit 0 set to 1 = Ultra DMA mode 0 is supported
	.time_sec_erase			dw 0		; 089	- Time required for security erase unit completion
	.time_enh_sec_erase		dw 0		; 090	- Time required for Enhanced security erase completion
	.current_apm_value		dw 0		; 091	- Current advanced power management value
	.master_pwd_rc			dw 0		; 092	- Master Password Revision Code
	.hardware_reset_result		dw 0		; 093	- (See manual for info)
	.acoustic_mng			dw 0		; 094	- bits 15-8 Vendor recommended acoustic management value
							;	  bits 7-0 Current automatic acoustic management value
	.stream_minimum_size		dw 0		; 095	- Stream Minimum Request Size
	.stream_transfer_time_dma	dw 0		; 096	- Streaming Transfer Time - DMA
	.stream_access_latency		dw 0		; 097	- Streaming Access Latency - DMA and PIO
	.stream_perf_granularity 	dd 0		; 098	- Streaming Performance Granularity [ 2 words ]
	.max_lba_48bit			dq 0		; 100	- Maximum user LBA for 48-bit Address feature set [ 4 words]
	.stream_transfer_time_pio	dw 0		; 104	- Streaming Transfer Time - PIO
	.word105			dw 0		; 105	- reserved
	.phys_log_sector_size		dw 0		; 106	- Physical sector size - Logical Sector Size
							;	  bit 15 Shall be cleared to zero
							;	  bit 14 Shall be set to one
							;	  bit 13 set to 1 = Device has multiple logical sectors per physical sector
							;	  bit 12 set to 1 = Device Logical Sector Longer than 256 Words
							;	  bits 11-4 Reserved
							;	  bits 3-0 2^x logical sectors per physical sector
	.interseek_delay		dw 0		; 107	- Inter-seek delay for ISO-7779 acoustic testing in microseconds
	.naa_oui			dw 0		; 108	- bits 15-12 NAA (3:0)
							;	- bits 11-0 IEEE OUI (23:12)
	.oui_unique_id_h		dw 0		; 109	- bits 15-4 IEEE OUI (11:0)
							;	- bits 3-0 Unique ID (35:32)
	.unique_id_m			dw 0		; 110	- Unique ID (31:16)
	.unique_id_l			dw 0		; 111	- Unique ID (15:0)
	.word112			dw 0		; 112	- Reserved
	.word113			dw 0		; 113	- Reserved
	.word114			dw 0		; 114	- Reserved
	.word115			dw 0		; 115	- Reserved
	.word116			dw 0		; 116	- Reserved
	.logical_sector_size1		dw 0		; 117	- Size of device logical sectors in words
	.logical_sector_size2		dw 0		; 118	- Size of device logical sectors in words
	.word119			dw 0		; 119	- Reserved
	.word120			dw 0		; 120	- Reserved
	.word121			dw 0		; 121	- Reserved
	.word122			dw 0		; 122	- Reserved
	.word123			dw 0		; 123	- Reserved
	.word124			dw 0		; 124	- Reserved
	.word125			dw 0		; 125	- Reserved
	.word126			dw 0		; 126	- Reserved
	.removable_media_status		dw 0		; 127	- bits 15-2 Reserved
							;	  bits 1-0 set to 00 = Removable Media Status Notification not supported
							;			  01 = Removable Media Status Notification supported
							;			  10 = Reserved
							;			  11 = Reserved
	.security_status		dw 0		; 128	- bits 15-9 Reserved
							;	  bit 8 Security level 0 = High, 1 = Maximum
							;	  bits 7-6 Reserved
							;	  bit 5 set to 1 = Enhanced security erase supported
							;	  bit 4 set to 1 = Security count expired
							;	  bit 3 set to 1 = Security frozen
							;	  bit 2 set to 1 = Security locked
							;	  bit 1 set to 1 = Security enabled
							;	  bit 0 set to 1 = Security supported
	.vendor_specific: TIMES 31	dw 0		; 129	- Vendor specific [ 31 words ]
	.cfa_power_mode1		dw 0		; 160	- bit 15 set to 1 = Word 160 supported
							;	  bit 14 Reserved
							;	  bit 13 set to 1 = CFA power mode 1 is required for one or more commands implemented
							;	  bit 12 set to 1 = CFA power mode 1 disabled
							;	  bits 11-0 Maximum current in ma
	.reserved_cfa:	TIMES 15	dw 0		; 161	- Reserved for assignment by the CompactFlashTM Association [ 15 words ]
	.current_serial_number: TIMES 30 dw 0		; 176	- Current media serial number [ 30 words ]
	.reserved206:	TIMES 49	dw 0		; 206	- Reserved [ 49 words ]
	.integrity			dw 0		; 255	- Integrity word
							;	  bits 15-8 Checksum
							;	  bits 7-0 Signature

	};end of structure

align 16
	ata00_info	ATA_IDENTIFYDEVICE_STRUCTURE
align 16
	ata01_info	ATA_IDENTIFYDEVICE_STRUCTURE
align 16
	ata10_info	ATA_IDENTIFYDEVICE_STRUCTURE
align 16
	ata11_info	ATA_IDENTIFYDEVICE_STRUCTURE

;---------------------------------------------------

; ===================================================================================================
; EOF


