;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.2 - GPL3 - Apr 2012
;
;-----------------------------------------------------------------------------------
; System Call Section -- Accessible to user programs
;-----------------------------------------------------------------------------------


include "syscalls/string.asm"
include "syscalls/smp.asm"
include "syscalls/memory.asm"
include "syscalls/misc.asm"
include "syscalls/sound.asm"
include "syscalls/screen.asm"
include "syscalls/input.asm"
include "syscalls/file.asm"
include "syscalls/debug.asm"


;--------------------------------------------------------------

align 16

TABLESYSCALLS:
;debug
	align 8
	dq os_debug_dump_reg
	align 8
	dq os_debug_dump_mem
	align 8
	dq os_debug_dump_rax
	align 8
	dq os_debug_dump_eax
	align 8
	dq os_debug_dump_ax
	align 8
	dq os_debug_dump_al
;file
	align 8
	dq os_fs_command_break
	align 8
	dq os_fs_command
;input
	align 8
	dq os_input_key_check
	align 8
	dq os_input_key_wait
	align 8
	dq os_input_string
;memory
	align 8
	dq os_mem_allocate
	align 8
	dq os_mem_release
	align 8
	dq os_mem_get_free
;misc
	align 8
	dq os_get_timecounter
	align 8
	dq os_delay
	align 8
	dq os_get_random
	align 8
	dq os_get_random_integer
	align 8
	dq os_get_argc
	align 8
	dq os_get_argv
	align 8
	dq os_get_strv
;screen
	align 8
	dq os_move_cursor
	align 8
	dq os_inc_cursor
	align 8
	dq os_dec_cursor
	align 8
	dq os_print_newline
	align 8
	dq os_print_string
	align 8
	dq os_print_string_with_color
	align 8
	dq os_print_char
	align 8
	dq os_print_char_with_color
	align 8
	dq os_print_chars
	align 8
	dq os_print_chars_with_color
	align 8
	dq os_print_char_hex
	align 8
	dq os_print_char_hex_with_color
	align 8
	dq os_screen_scroll
	align 8
	dq os_screen_clear
	align 8
	dq os_screen_clear_from_cursor
	align 8
	dq os_row_clear
	align 8
	dq os_hide_cursor
	align 8
	dq os_show_cursor
;smp
	align 8
	dq os_smp_reset
	align 8
	dq os_smp_wakeup
	align 8
	dq os_smp_wakeup_all
	align 8
	dq os_smp_get_id
	align 8
	dq os_smp_enqueue
	align 8
	dq os_smp_dequeue
	align 8
	dq os_smp_run
	align 8
	dq os_smp_queuelen
	align 8
	dq os_smp_numcores
	align 8
	dq os_smp_wait
	align 8
	dq os_smp_lock
	align 8
	dq os_smp_unlock
;sound
	align 8
	dq os_speaker_tone
	align 8
	dq os_speaker_on
	align 8
	dq os_speaker_off
	align 8
	dq os_speaker_beep
;string
	align 8
	dq os_int_to_string
	align 8
	dq os_string_to_int
	align 8
	dq os_int_to_hex_string
	align 8
	dq os_hex_string_to_int
	align 8
	dq os_string_length
	align 8
	dq os_string_find_char
	align 8
	dq os_string_change_char
	align 8
	dq os_string_copy
	align 8
	dq os_string_truncate
	align 8
	dq os_string_join
	align 8
	dq os_string_append
	align 8
	dq os_string_chomp
	align 8
	dq os_string_strip
	align 8
	dq os_string_compare
	align 8
	dq os_string_uppercase
	align 8
	dq os_string_lowercase
	align 8
	dq os_is_digit
	align 8
	dq os_is_alpha
	align 8
	dq os_string_parse
	align 8
	dq os_get_date_string
	align 8
	dq os_get_time_string
	align 8
	dq os_get_datetime_string
	align 8
	dq os_byte_to_8digit_string


; =============================================================================
; EOF
