;-----------------------------------------------------------------------------------
; BareNumbersOS v.0.2 - GPL3 - Apr 2012
;
;-----------------------------------------------------------------------------------
;
; File System commands executor
;-----------------------------------------------------------------------------------

;os_fs_command_break
;os_fs_command

;---------------------------------------------------------------------------
; os_fs_command_break - Break the contents of string into individual strings
; IN: 	RSI = command arguments string
; OUT:	RSI = command arguments string (breaked)
; 	RCX = num. of words in the string
os_fs_command_break:
	push rax
	push rbx

	; os_string_parse stores the number of words in RCX
	call os_string_parse		; Remove extra spaces

	; Break the contents of string into individual strings
	mov al, 0x20
	mov bl, 0x00
	call os_string_change_char

	pop rbx
	pop rax
	ret

;---------------------------------------------------------------------------
; os_fs_command - File system commands executor
; IN: 	RSI = command arguments string (breaked)
;	RCX = num. of words in the string
; 	RAX = ptr to file in memory	(STO)
;	RBX = size			(STO)
; OUT:	RAX = ptr to file in memory	(LIM)
;	RBX = size			(LIM)
;	set carry
os_fs_command:
	mov di, word[rsi]		; First 2 chars
	cmp di, 'CP'			; Copy file
	je .cm
	mov di, word[rsi]		; First 2 chars
	cmp di, 'MV'			; Move file
	je .cm

	call fs_command
	jc .error
	clc
	jmp .end
.cm:
	call fs_command2
	jc .error
	clc
	jmp .end

.error:
	stc
.end:
	ret


; ===================================================================================================
; EOF

